package scanner

import (
	"git.urbach.dev/cli/q/src/build"
	"git.urbach.dev/cli/q/src/fs"
)

// Scan scans all the files included in the build.
func Scan(b *build.Build) (<-chan *fs.File, <-chan error) {
	s := scanner{
		files:  make(chan *fs.File),
		errors: make(chan error),
		build:  b,
	}

	go func() {
		s.queue(b.Files...)
		s.group.Wait()
		close(s.files)
		close(s.errors)
	}()

	return s.files, s.errors
}